<#ibiztemplate>
TARGET=PSSYSAPP
</#ibiztemplate>
<#comment>脚本执行日志路径。</#comment>
<#assign outputlog= " > " + codefolder+"\\"+sys.getPSDevCenterDomain()+"\\"+sys.getPubSystemId()+"\\"+sys.getVCName()+"\\"+"app_"+app.getPKGCodeName()+"\\run.log">
<#assign outputlog2= " > " + codefolder+"\\"+sys.getPSDevCenterDomain()+"\\"+sys.getPubSystemId()+"\\"+sys.getVCName()+"\\"+"app_"+app.getPKGCodeName()+"\\">

<#assign workshop="workshop">
<#if sys.getPSSVNInstRepo()?? && sys.getPSSVNInstRepo().getSVNType() =="GIT">
<#assign workshop="gitshop">
</#if>

<#assign ibizsys_base_file = '${app.getPFType()}'>
<#if pfstyle.getVersionString()?? && (pfstyle.getVersionString() != '')>
<#assign ibizsys_base_file += '-${pfstyle.getVersionString()}'>
</#if>

<#comment>关闭回显并开启变量延迟。</#comment>
@echo off&setlocal ENABLEDELAYEDEXPANSION

rem ---------------------------------------------------------------------------
rem   publisher		前端应用发布器PSJQAppCreateAppBatPublisherImpl 
rem   app			前端应用
rem   sys			后台服务系统
rem   pf			前端应用技术体系
rem   pfstyle		前端应用样式
rem   apptempl		应用模板
rem   toolfolder	发布工具目录路径
rem   codefolder	发布代码根目录路径 
rem ---------------------------------------------------------------------------
<#if !pub.isUseWorkshopServer() >
rem 建立前端应用相关工作空间目录。 
mkdir ${codefolder}\${sys.getPSDevCenterDomain()}
mkdir ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}
mkdir ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}
mkdir ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}
mkdir ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}\build
mkdir ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}\src
mkdir ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}_pub
mkdir ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}_pub\src
mkdir ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}_usr
mkdir ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}_usr\src

rem 为发布代码添加归档标记，便于后续文件的判别处理，如增量更新、文件增量修改的版本库提交等。
attrib +A ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${sys.getVCName()}\app_${app.getPKGCodeName()}\WEB\*.*  /S
attrib +A ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${sys.getVCName()}\app_${app.getPKGCodeName()}\APP\*.*  /S
attrib +A ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${sys.getVCName()}\app_${app.getPKGCodeName()}\USERCODE\APP_PUB\*.*  /S

rem 拷贝自动发布代码到合成项目。
xcopy ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${sys.getVCName()}\app_${app.getPKGCodeName()}\WEB\*.* ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}\src /I/E/Y/D ${outputlog}
xcopy ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${sys.getVCName()}\app_${app.getPKGCodeName()}\APP\src\*.* ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}\src /I/E/Y/D ${outputlog}
xcopy ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${sys.getVCName()}\app_${app.getPKGCodeName()}\USERCODE\APP_PUB\*.* ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}\src /I/E/Y ${outputlog}

<#comment>
rem 实现合成项目中文件（大小写差异）改名功能。实现原理：需要该名称的文件会追加.rename后缀，第一个for查询改名的文件并删除，第二个for查处对应的文件去掉.rename后缀。
for /f "delims=" %%i in ('dir ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}\*.rename /b /s') do set info=%%i&del !info:~0,-7! /F/Q
for /f "delims=" %%i in ('dir ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}\*.rename /b /s') do set info=%%i&move /Y !info! !info:~0,-7!
</#comment>

<#if publisher.getContext().isRebuildMode()>
rem 重构模式

rem pub项目取消归档标记
attrib -A ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}_pub\src\*.*  /S

rem 完全拷贝前端初始化代码相关文件。
xcopy ${toolfolder}\APP\${ibizsys_base_file}\APP\*.* ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}\src /E/Y ${outputlog}
<#if sys.getPSSVNInstRepo()??>
xcopy ${toolfolder}\APP\${ibizsys_base_file}\APP\*.* ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}_pub /E/Y ${outputlog}
</#if>

rem 拷贝自动发布代码到pub项目
xcopy ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${sys.getVCName()}\app_${app.getPKGCodeName()}\WEB\*.* ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}_pub\src /E/Y/D ${outputlog}
xcopy ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${sys.getVCName()}\app_${app.getPKGCodeName()}\APP\src\*.* ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}_pub\src /E/Y/D ${outputlog}
rem 拷贝用户自定义文件到pub项目
xcopy ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${sys.getVCName()}\app_${app.getPKGCodeName()}\USERCODE\APP_PUB\*.* ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}_pub /I/E/Y ${outputlog}

rem 实现pub项目文件改名功能。实现原理同上。
for /f "delims=" %%i in ('dir ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}_pub\*.rename /b /s') do set info=%%i&del !info:~0,-7! /F/Q
for /f "delims=" %%i in ('dir ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}_pub\*.rename /b /s') do set info=%%i&move /Y !info! !info:~0,-7!

<#if publisher.context.isEnableVC() && (sys.getPSSVNInstRepo().getSVNType()=="GIT")>
rem 指定了版本库，将pub和usr代码与版本库同步。
"${toolfolder}\jdk1.8\bin\java.exe" -cp ${toolfolder}\js\saibz5.jar net.ibizsys.paas.builder.GitHelper ${sys.getPSSVNInstRepo().getPSGitUser().getResCfgFilePath()} ${sys.getPSSVNInstRepo().getGitPath()}  ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}_pub APP_PUB
"${toolfolder}\jdk1.8\bin\java.exe" -cp ${toolfolder}\js\saibz5.jar net.ibizsys.paas.builder.GitHelper ${sys.getPSSVNInstRepo().getPSGitUser().getResCfgFilePath()} ${sys.getPSSVNInstRepo().getGitPath()}  ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}_usr APP_USR
<#elseif publisher.context.isEnableVC() && (sys.getPSSVNInstRepo().getSVNType()=="SVN")>
"${toolfolder}\java\bin\java.exe" -cp ${toolfolder}\js\saibz5.jar net.ibizsys.paas.builder.SvnCmd3 ${sys.getReadOnlyPSSVNInstRepo().getConnStr()}/${sys.getPSDevSlnCodeName()}/${sys.getTrunkSysName()}/${sys.getVCName()}  ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}_pub APP_PUB <#if publisher.context.getRebuildModeEx()!=2>REBUILD</#if>
"${toolfolder}\java\bin\java.exe" -cp ${toolfolder}\js\saibz5.jar net.ibizsys.paas.builder.SvnCmd3 ${sys.getPSSVNInstRepo().getConnStr()}/${sys.getPSDevSlnCodeName()}/${sys.getTrunkSysName()}/${sys.getVCName()}  ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}_usr APP_USR
</#if>

rem 拷贝usr代码到合成项目
xcopy ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}_usr\src\*.* ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}\src  /I/E/Y ${outputlog}

<#else>
rem 标准发布

rem 增量拷贝初始文件
xcopy ${toolfolder}\APP\${ibizsys_base_file}\APP\*.* ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}\src /E/Y/D ${outputlog}
<#if sys.getPSSVNInstRepo()??>
xcopy ${toolfolder}\APP\${ibizsys_base_file}\APP\*.* ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}_pub /E/Y/D ${outputlog}
</#if>

rem 拷贝自动发布代码到pub项目
xcopy ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${sys.getVCName()}\app_${app.getPKGCodeName()}\WEB\*.* ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}_pub\src /E/Y/D ${outputlog}
xcopy ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${sys.getVCName()}\app_${app.getPKGCodeName()}\APP\src\*.* ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}_pub\src /E/Y/D ${outputlog}
rem 拷贝用户自定义文件到pub项目
xcopy ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${sys.getVCName()}\app_${app.getPKGCodeName()}\USERCODE\APP_PUB\*.* ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}_pub /I/E/Y ${outputlog}

rem 实现pub项目文件改名功能。实现原理同上。
for /f "delims=" %%i in ('dir ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}_pub\*.rename /b /s') do set info=%%i&del !info:~0,-7! /F/Q
for /f "delims=" %%i in ('dir ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}_pub\*.rename /b /s') do set info=%%i&move /Y !info! !info:~0,-7!

rem 如果指定了版本库，将pub和usr代码与版本库同步。
<#if publisher.context.isEnableVC() && (sys.getPSSVNInstRepo().getSVNType()=="GIT")>
"${toolfolder}\jdk1.8\bin\java.exe" -cp ${toolfolder}\js\saibz5.jar net.ibizsys.paas.builder.GitHelper ${sys.getPSSVNInstRepo().getPSGitUser().getResCfgFilePath()} ${sys.getPSSVNInstRepo().getGitPath()}  ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}_pub APP_PUB
"${toolfolder}\jdk1.8\bin\java.exe" -cp ${toolfolder}\js\saibz5.jar net.ibizsys.paas.builder.GitHelper ${sys.getPSSVNInstRepo().getPSGitUser().getResCfgFilePath()} ${sys.getPSSVNInstRepo().getGitPath()}  ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}_usr APP_USR
<#elseif publisher.context.isEnableVC() && (sys.getPSSVNInstRepo().getSVNType()=="SVN")>
"${toolfolder}\java\bin\java.exe" -cp ${toolfolder}\js\saibz5.jar net.ibizsys.paas.builder.SvnCmd3 ${sys.getReadOnlyPSSVNInstRepo().getConnStr()}/${sys.getPSDevSlnCodeName()}/${sys.getTrunkSysName()}/${sys.getVCName()}  ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}_pub APP_PUB
"${toolfolder}\java\bin\java.exe" -cp ${toolfolder}\js\saibz5.jar net.ibizsys.paas.builder.SvnCmd3 ${sys.getPSSVNInstRepo().getConnStr()}/${sys.getPSDevSlnCodeName()}/${sys.getTrunkSysName()}/${sys.getVCName()}  ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}_usr APP_USR
</#if>

rem 拷贝usr代码到合成项目
xcopy ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}_usr\*.* ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}\src  /E/Y ${outputlog}

</#if>
rem 删除合成项目中.rename后缀的文件
del ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${sys.getVCName()}\app_${app.getPKGCodeName()}\*.rename /S/Q/F ${outputlog}

<#if !syspub.isPubCodeOnly()>
rem 判断是否远程打包
<#if !sys.getPSDeployServer()??>
rem 不存在远程打包服务器
rem 编译合成项目
chdir /D ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}\src\
call ${toolfolder}\node\npm i 
call ${toolfolder}\node\npm rebuild node-sass
call ${toolfolder}\node\npm run build 

ping -n 3 127.0.0.1>nul
rem 拷贝合成项目编译结果到构建目录
xcopy ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}\src\dist\*.* ${codefolder}\${sys.getPSDevCenterDomain()}\${sys.getPubSystemId()}\${workshop}\app_${app.getPKGCodeName()}\build /E/Y ${outputlog2}run_dist.log
</#if>
<#else>
echo Build complete
</#if>
<#else>
echo Build complete
</#if>